Index: contrib/smbfs/lib/smb/nb_name.c
===================================================================
--- contrib/smbfs/lib/smb/nb_name.c	(revision 277169)
+++ contrib/smbfs/lib/smb/nb_name.c	(working copy)
@@ -150,7 +150,13 @@
 memsetw(char *dst, int n, u_short word)
 {
 	while (n--) {
+#if defined(__arm__)
+		// NBENCODE() use htole16
+		*(dst + 1) = (word >> 8) & 0xffU;
+		*(dst + 0) = (word >> 0) & 0xffU;
+#else
 		*(u_short*)dst = word;
+#endif
 		dst += 2;
 	}
 }
@@ -165,18 +171,35 @@
 	*cp++ = NB_ENCNAMELEN;
 	name = np->nn_name;
 	if (name[0] == '*' && name[1] == 0) {
+#if defined(__arm__)
+		*(cp + 1) = (NBENCODE('*') >> 8) & 0xffU;
+		*(cp + 0) = (NBENCODE('*') >> 0) & 0xffU;
+#else
 		*(u_short*)cp = NBENCODE('*');
+#endif
 		memsetw(cp + 2, NB_NAMELEN - 1, NBENCODE(' '));
 		cp += NB_ENCNAMELEN;
 	} else {
 		for (i = 0; *name && i < NB_NAMELEN - 1; i++, cp += 2, name++)
+#if defined(__arm__)
+		{
+			*(cp + 1) = (NBENCODE(toupper(*name)) >> 8) & 0xffU;
+			*(cp + 0) = (NBENCODE(toupper(*name)) >> 0) & 0xffU;
+		}
+#else
 			*(u_short*)cp = NBENCODE(toupper(*name));
+#endif
 		i = NB_NAMELEN - i - 1;
 		if (i > 0) {
 			memsetw(cp, i, NBENCODE(' '));
 			cp += i * 2;
 		}
+#if defined(__arm__)
+		*(cp + 1) = (NBENCODE(np->nn_type) >> 8) & 0xffU;
+		*(cp + 0) = (NBENCODE(np->nn_type) >> 0) & 0xffU;
+#else
 		*(u_short*)cp = NBENCODE(np->nn_type);
+#endif
 		cp += 2;
 	}
 	*cp = 0;
